moDraw.slots = {};

function moDraw.slots:setOpenPdaSlot(self, slot, slotName)	
	if moGuiMiniPdaSlots.values[slot].foundObjects == 0 or moGuiMiniPdaSlots.values[slot].objects == nil then
		moGuiExtras:closeOpenSlot(self, slot, true, false);
		g_currentMission:showBlinkingWarning(tostring(moLanguageXml:getTxt("slotno")), 2500);
		return;
	end;
	----
	local slotObjects = moGuiMiniPdaSlots.values[slot].objects;
	if moGuiMiniPdaSlots.values[slot].permUpdate then MultiOverlayV2:setSlotUpdate(self, slot);end;
	moGuiExtras:setSlotMaxProSwitch(self, slot);
	moGuiExtras:setSlotFirstEndObjects(self, slot);
	local firstObjectDisplay, endObjectDisplay = moGuiMiniPdaSlots.values[slot].firstObject, moGuiMiniPdaSlots.values[slot].endObject;
	local tempObjectDisplay = 0;
	----
	local hotSpot = moGuiMiniPdaSlots.values[slot].hotSpot;
	--local slotEdit = moGuiMiniPdaSlots.values[slot].edit;
	--if slotEdit then moGuiMiniPdaSlots.values[slot].clickArea.slotEdit = {};end;
	local seeSmall = moGuiMiniPdaSlots.values[slot].seeSmall;
	if hotSpot then moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot = {};end;
	if not seeSmall then moGuiMiniPdaSlots.values[slot].clickArea.slotSeeSmall = {};end;
	local posX = moGuiMiniPdaSlots.values[slot].openX+0.001;
	local posY = moGuiMiniPdaSlots.values[slot].openY;
	if not moGuiMiniPdaSlots.values[slot].settings and moGeneralSettings.seasonsMod and g_seasons ~= nil and moGuiMiniPdaSlots.values[slot].seasonsAutoPos then
		local seasonsModOld = false;
		local visible = nil;
		if g_seasons.forecast.hud ~= nil and g_seasons.forecast.hud.visible ~= nil then seasonsModOld = true;visible = Utils.getNoNil(g_seasons.forecast.hud.visible,nil);
		else visible = Utils.getNoNil(g_seasons.forecast.visible,nil);end;		
		if visible ~= nil and visible then		
			if seasonsModOld then
				if posY >= g_seasons.forecast.hud.posY and posX+moGuiMiniPdaSlots.values[slot].openLastWidth >= g_seasons.forecast.hud.posX then
					moGuiMiniPdaSlots.values[slot].openY = moGuiMiniPdaSlots.values[slot].openY - (g_seasons.forecast.hud.overlays.forecast_hud.height / (3-Utils.getNoNil(g_gameSettings:getValue("uiScale"), 1)));
					posY = moGuiMiniPdaSlots.values[slot].openY;
					moMouseClickAreas:setSlotCfg(self, slot);
				end;
			else				
				if posY >= g_seasons.forecast.forecastY and posX+moGuiMiniPdaSlots.values[slot].openLastWidth >= g_seasons.forecast.forecastX then
					moGuiMiniPdaSlots.values[slot].openY = moGuiMiniPdaSlots.values[slot].openY - g_seasons.forecast.forecastHeight;
					posY = moGuiMiniPdaSlots.values[slot].openY;
					moMouseClickAreas:setSlotCfg(self, slot);
				end;
			end;			
		elseif  visible ~= nil and not visible then	
			if seasonsModOld then
				if posY <= g_seasons.forecast.hud.posY and posX+moGuiMiniPdaSlots.values[slot].openLastWidth >= g_seasons.forecast.hud.posX then
					moGuiMiniPdaSlots.values[slot].openY = moGuiMiniPdaSlots.values[slot].openY + (g_seasons.forecast.hud.overlays.forecast_hud.height / (3-Utils.getNoNil(g_gameSettings:getValue("uiScale"), 1)));
					posY = moGuiMiniPdaSlots.values[slot].openY;
					moMouseClickAreas:setSlotCfg(self, slot);
				end;
			else
				if posY <= g_seasons.forecast.forecastY and posX+moGuiMiniPdaSlots.values[slot].openLastWidth >= g_seasons.forecast.forecastX then
					moGuiMiniPdaSlots.values[slot].openY = moGuiMiniPdaSlots.values[slot].openY + g_seasons.forecast.forecastHeight;
					posY = moGuiMiniPdaSlots.values[slot].openY;
					moMouseClickAreas:setSlotCfg(self, slot);
				end;
			end;
		end;
	end;
	local size = moGuiMiniPdaSlots.values[slot].size;
	local distanceLine = moGuiMiniPdaSlots.values[slot].distanceLine;
	local widthSettings = moSetGetGui.buttonGfxWidth1*moSetGetGui.zoomOutInTemp*4;
	local heightSettings = moSetGetGui.buttonGfxHeight1*moSetGetGui.zoomOutInTemp*4;	
	local height = moSetGetGui.buttonGfxHeight1*(size*1000);
	local heightDefault = moSetGetGui.buttonGfxHeight1*(size*1000);
	local distanceDif = moGuiMiniPdaSlots.values[slot].distanceDif; --fillcontainer <----> filllevel
	local slotLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGuiMiniPdaSlots.values[slot].length+moSetGetGui.screenAspectRatio);	
	local width = slotLength+distanceDif;	
	local widthNext = 0;
	local currentPosY = posY;
	function nextLine(setHeight, posYnew, setLine, posYline, widthLine, heightLine, onlyLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-0.001, currentPosY-(posYline), widthLine, heightLine);
			moSetGetGui["designLine"]:render();
			if onlyLine then return;end;
		end;		
		if setHeight then height = height+(heightDefault)+posYnew;end; --height+size+posNew;
		currentPosY = currentPosY-(heightDefault)-posYnew; --posY-(size+posYnew);		
	end;	
	moSetGetGui["designGround".. slot]:render();
	setTextBold(true);	
	setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
	local sizeTemp = 0.010;
	if size < sizeTemp then sizeTemp = size;end;
	if moGuiMiniPdaSlots.keySwitchLast == slot then
		if not moGuiMiniPdaSlots.values[slot].settings then
			moSetGetGui["slotCfg"]:setPosition(posX, posY);
			moSetGetGui["slotCfg"]:render();
		else
			moSetGetGui["slotPos"]:setPosition(posX, posY);
			moSetGetGui["slotPos"]:render();
		end;
		nextLine(true, 0.005, false);
		moSetGetGui["slotFruit"]:setPosition(posX+(widthSettings*1), posY);
		moSetGetGui["slotFruit"]:render();		
		if not moGuiMiniPdaSlots.values[slot].seeInOutFruit then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*1), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		moSetGetGui["slotMoney"]:setPosition(posX+(widthSettings*2), posY);
		moSetGetGui["slotMoney"]:render();		
		if not moGuiMiniPdaSlots.values[slot].seePrice then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*2), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		moSetGetGui["slotPlus"]:setPosition(posX+(widthSettings*3), posY);
		moSetGetGui["slotPlus"]:render();		
		if moGuiMiniPdaSlots.values[slot].seeSmall then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*3), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
		if not moGuiMiniPdaSlots.values[slot].hotSpot then
			moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
			moSetGetGui["slotHotSpot"]:render();
			moSetGetGui["slotNotOkay"]:setPosition(posX, posY-(heightSettings));
			moSetGetGui["slotNotOkay"]:render();
		else
			if moGuiMiniPdaSlots.isHotSpotObj then
				if moGuiMiniPdaSlots.hotSpotBlinkTemp <= moGuiMiniPdaSlots.hotSpotBlinkTime then --warningBlinkTime, warningBlinkTemp
					moGuiMiniPdaSlots.hotSpotBlinkTemp = moGuiMiniPdaSlots.hotSpotBlinkTemp+1			
					moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
					moSetGetGui["slotHotSpot"]:render();			
				else
					moGuiMiniPdaSlots.hotSpotBlinkTemp = moGuiMiniPdaSlots.hotSpotBlinkTemp+1
					if moGuiMiniPdaSlots.hotSpotBlinkTemp >= moGuiMiniPdaSlots.hotSpotBlinkTime*2 then moGuiMiniPdaSlots.hotSpotBlinkTemp = 0;end;
				end;
			else
				moSetGetGui["slotHotSpot"]:setPosition(posX, posY-(heightSettings));
				moSetGetGui["slotHotSpot"]:render();
			end;
		end;
		moSetGetGui["slotEdit"]:setPosition(posX+(widthSettings*1), posY-(heightSettings));
		moSetGetGui["slotEdit"]:render();
		--if not moGuiMiniPdaSlots.values[slot].edit then
		--	moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*1), posY-(heightSettings));
		--	moSetGetGui["slotNotOkay"]:render();
		--end;
		moSetGetGui["slotSwitchL"]:setPosition(posX+(widthSettings*4), posY);
		moSetGetGui["slotSwitchL"]:render();
		renderText(posX+(widthSettings*4.7), posY+0.0035, sizeTemp, tostring(moGuiMiniPdaSlots.values[slot].switch));
		moSetGetGui["slotSwitchR"]:setPosition(posX+(widthSettings*5), posY);
		moSetGetGui["slotSwitchR"]:render();
		moSetGetGui["slotNextL"]:setPosition(posX+(widthSettings*6), posY);
		moSetGetGui["slotNextL"]:render();
		moSetGetGui["slotNextR"]:setPosition(posX+(widthSettings*8), posY);
		moSetGetGui["slotNextR"]:render();
		renderText(posX+(widthSettings*7.2), posY+0.0035, sizeTemp, tostring(moGuiMiniPdaSlots.values[slot].maxProSwitch));					
	else
		moSetGetGui["slotNotReady"]:setPosition(posX, posY-(heightSettings));
		moSetGetGui["slotNotReady"]:render();
		nextLine(true, 0.005, false);
		renderText(posX, posY+0.0035, sizeTemp, "Slotname:  ".. tostring(moGuiMiniPdaSlots.values[slot].name));
	end;	
	----
	renderText(posX+(widthSettings*2.1), currentPosY, size, tostring(moLanguageXml:getTxt("objects", nil, "Objects")).. ": ".. tostring(firstObjectDisplay).. "-".. tostring(endObjectDisplay));
	setTextAlignment(2);
	setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
	renderText(posX+width-distanceDif, currentPosY, size, tostring(moGuiMiniPdaSlots.values[slot].foundObjects));		
	setTextAlignment(0);	
	nextLine(true, 0.007, true, 0.0035, width+widthNext, 0.001);
	---------------------------------------------------------------	
	function setDrawFillTypes(objectTable, objectTableFillTypes, input, stocks, heaps, shops, trees)		
		if shops then input = false;end; --heaps
		setTextAlignment(0);
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		if objectTableFillTypes.lengthFillTypes == nil then
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor4));
			renderText(posX, currentPosY, size, tostring("modType not correctly !!"));
			nextLine(true, distanceLine, false)
			renderText(posX, currentPosY, size, "if error xml or corrupt table !!");
			return;
		end;		
		local fillTypeContainerName = tostring(moLanguageXml:getTxt("fillcontainer", nil, "Fillcontainer"));
		local fillTypeName = "";
		local toLong = false;
		--local capacity = g_i18n:formatNumber(Utils.getNoNil(objectTableFillTypes.capacity, 0)); --string.format("%1.0f", Utils.getNoNil(objectTableFillTypes.capacity, 0));
		--local fillLevel = g_i18n:formatNumber(Utils.getNoNil(objectTableFillTypes.fillLevel,0)); --string.format("%1.0f", Utils.getNoNil(objectTableFillTypes.fillLevel, 0));
		local capacity = string.format("%1.0f", Utils.getNoNil(objectTableFillTypes.capacity, 0));		
		local fillLevel = string.format("%1.0f", Utils.getNoNil(objectTableFillTypes.fillLevel, 0));
		if capacity ~= "nan" and capacity ~= "inf" then
			capacity = g_i18n:formatNumber(tonumber(capacity));			
		else
			capacity = 0;
			objectTableFillTypes.capacity = 0;
		end;
		if fillLevel ~= "nan" and fillLevel ~= "inf" then
			fillLevel = g_i18n:formatNumber(tonumber(fillLevel));			
		else
			fillLevel = 0;
			objectTableFillTypes.fillLevel = 0;
		end;		
		local fillProzentString = "";
		local fillLevelString = "";
		if heaps then capacity = "";end;		
		if objectTableFillTypes.lengthFillTypes > 1 then
			if objectTableFillTypes.fillTypeContainerName ~= nil then fillTypeContainerName = tostring(objectTableFillTypes.fillTypeContainerName);end;	
			local stringLength = moSetGetGui.buttonGfxWidth1*(sizeTemp*1000/1.5)*(string.len(objectTableFillTypes.fillTypeName)/1.05+(moSetGetGui.screenAspectRatio)); --moSetGetGui.buttonGfxWidth1*(sizeTemp*1000/1.5)*(string.len(objectTableFillTypes.fillTypeName)/1.2+(moSetGetGui.screenAspectRatio));
			if tonumber(width) > tonumber(stringLength) then								
				fillTypeName = tostring(objectTableFillTypes.fillTypeName);
			else
				local splitNames = Utils.splitString(",", objectTableFillTypes.fillTypeName);				
				fillTypeName = tostring(moLanguageXml:getTxt("toolong1")).. "(".. tostring(table.getn(splitNames)).. " ".. tostring(moLanguageXml:getTxt("toolong2")).. ")";				
				toLong = true;
			end;			
		else			
			if string.find(objectTableFillTypes.fillTypeName, "!") then setTextColor(unpack(moGuiMiniPdaSlots.warningColor4));end;
			if objectTableFillTypes.capacity ~= -2 or objectTableFillTypes.capacity ~= -3 then fillTypeContainerName = tostring(objectTableFillTypes.fillTypeName);end;	
			if objectTableFillTypes.fillTypeContainerName ~= nil then fillTypeContainerName = tostring(objectTableFillTypes.fillTypeContainerName);end;	
		end;						
		if heaps and Utils.getNoNil(objectTableFillTypes.fillLevel, 0) < 0.1 then setTextColor(unpack(moGuiMiniPdaSlots.warningColor2));end;		
		renderText(posX, currentPosY, size, tostring(fillTypeContainerName));		
		setTextAlignment(2);					
		if moGuiMiniPdaSlots.values[slot].seeFillLevel then fillLevelString = "|".. tostring(fillLevel).. "L";end;
		if not heaps and moGuiMiniPdaSlots.values[slot].seeFillProzent and tonumber(objectTableFillTypes.capacity) > 0 then fillProzentString = "|".. string.format("%0.1f",Utils.getNoNil((tonumber(objectTableFillTypes.fillLevel)/tonumber(objectTableFillTypes.capacity)*100),0 )).. "%";end;
		if objectTableFillTypes.setColor ~= nil then setTextColor(unpack(objectTableFillTypes.setColor));else setTextColor(unpack(moGuiMiniPdaSlots.siloColor));end;
		if objectTableFillTypes.capacity == -1 then
			renderText(posX+width-distanceDif, currentPosY, size, tostring(fillLevel));
		elseif objectTableFillTypes.capacity == 0 then
			renderText(posX+width-distanceDif, currentPosY, size, tostring(fillLevel).. "L");
		elseif objectTableFillTypes.capacity == -2 then
			if objectTableFillTypes.extraText ~= nil then renderText(posX+width-distanceDif, currentPosY, size, tostring(objectTableFillTypes.extraText));end;
		elseif objectTableFillTypes.capacity == -3 then
			--if objectTableFillTypes.bestPrice ~= nil and objectTableFillTypes.bestPrice > 0.1 then
			--	local bestPriceTemp = string.format("%.1f", Utils.getNoNil(objectTableFillTypes.bestPrice, 0));
			--	renderText(posX+width-distanceDif, currentPosY, size, tostring(bestPriceTemp).. " ".. tostring(moLanguageXml:getTxt("moneysymbol")));
			--end;			
		else
			renderText(posX+width-distanceDif, currentPosY, size, tostring(capacity).. tostring(fillLevelString).. tostring(fillProzentString));
		end;
		setTextAlignment(0);
		if moGuiMiniPdaSlots.values[slot].seeInOutFruit and input and objectTableFillTypes.lengthFillTypes > 1 then
			nextLine(true, distanceLine/3, false);
			setTextAlignment(2);
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));			
			renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(fillTypeName));			
			if toLong and not seeSmall then
				moDraw.slots:setClickAreaSeeSmall(self, posX, currentPosY-(0.0025), width, heightDefault, objectTableFillTypes.fillTypeName, objectTable.displayName, slot);
				moSetGetGui["slotPlus"]:setPosition(posX, currentPosY-(0.0025));
				moSetGetGui["slotPlus"]:render();
			end;
			setTextAlignment(0);
		end;
		if moGuiMiniPdaSlots.values[slot].seePrice and not input and objectTableFillTypes.bestPrice ~= nil and tonumber(objectTableFillTypes.bestPrice) > 0.1 then
			nextLine(true, distanceLine/2, false);
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor1));
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt("price", nil, "Price")));
			setTextAlignment(2);			
			local bestPriceTemp = string.format("%.1f", Utils.getNoNil(objectTableFillTypes.bestPrice, 0));
			renderText(posX+width-distanceDif, currentPosY, size, tostring(bestPriceTemp).. " ".. tostring(moLanguageXml:getTxt("moneysymbol")));
			setTextAlignment(0);
		end;		
		if trees then
			if objectTable.lengthActive > 0 then
				nextLine(true, distanceLine/2, false);
				setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
				renderText(posX, currentPosY, sizeTemp, tostring(moLanguageXml:getTxt("treesactive")));
				setTextAlignment(2);
				setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
				renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(objectTable.lengthActive));
				setTextAlignment(0);
			end;
			if objectTable.lengthNotActive > 0 then
				nextLine(true, distanceLine/2, false);
				setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
				renderText(posX, currentPosY, sizeTemp, tostring(moLanguageXml:getTxt("treesnotactive")));
				setTextAlignment(2);
				setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
				renderText(posX+width-distanceDif, currentPosY, sizeTemp, tostring(objectTable.lengthNotActive));
				setTextAlignment(0);
			end;
		end;
	end;	
	function setObjectDisplay(objectTable)		
		local stocks = false;
		local heaps = false;
		local shops = false;
		local trees = false;
		setTextBold(true);
		setTextAlignment(0);
		setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
		--if slotEdit and objectTable.slotEdit then
		--	moSetGetGui["slotEdit"]:setPosition(posX, currentPosY);
		--	moSetGetGui["slotEdit"]:render();
		--	renderText(posX+(widthSettings*1), currentPosY, size, objectTable.displayName);
		--	moDraw.slots:setClickAreaSlotEdit(self, posX, currentPosY, width/2, heightDefault, objectTable, slot, slotName);
		--else
			renderText(posX, currentPosY, size, objectTable.displayName);
		--end;
		if hotSpot then moDraw.slots:setClickAreaHotSpot(self, posX, currentPosY, width/2, heightDefault, objectTable.x, objectTable.z, objectTable.displayName, slot);end;
		setTextAlignment(2);
		setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
		renderText(posX+width-distanceDif, currentPosY, size, tostring(objectTable.length));
		setTextAlignment(0);
		nextLine(true, distanceLine/2, false);		
		setTextBold(false);
		if objectTable.category == "stocks" then stocks = true;end;
		if objectTable.category == "heaps" then heaps = true;end;
		if objectTable.category == "shops" then shops = true;end;
		if objectTable.category == "trees" then trees = true;end;
		if not stocks and not heaps and not shops then
			setTextColor(unpack(objectTable.productivityColor));
			local productivityTxt = "productivity1";
			if objectTable.category == "animals" then productivityTxt = "productivity";end;
			renderText(posX, currentPosY, size, tostring(moLanguageXml:getTxt(productivityTxt, nil, "Productivity")));
			setTextAlignment(2);
			local productivity = string.format("%0.0f", Utils.getNoNil(objectTable.productivity, 0));
			if productivity == "nan" or productivity == "inf" then productivity = 0;end;
			renderText(posX+width-distanceDif, currentPosY, size, tostring(productivity).. "%");
			setTextAlignment(0);
			nextLine(true, distanceLine/2, false);
		end;
		local foundOutputFillTypes = false;			
		if not shops and table.getn(objectTable.outputFillTypes) > 0 then --not heaps
			for container=1, table.getn(objectTable.outputFillTypes) do
				foundOutputFillTypes = true;					
				setDrawFillTypes(objectTable, objectTable.outputFillTypes[container], false, stocks, heaps, shops, trees);
				if container < table.getn(objectTable.outputFillTypes) then nextLine(true, distanceLine, false);end;
			end;
		end;			
		if not stocks and not moGuiMiniPdaSlots.values[slot].seeSmall then
			if foundOutputFillTypes and table.getn(objectTable.inputFillTypes) > 0 then nextLine(true, distanceLine, true, 0.0035, width/3, 0.001);end;
			for container=1, table.getn(objectTable.inputFillTypes) do				
				setDrawFillTypes(objectTable, objectTable.inputFillTypes[container], true, stocks, heaps, shops, trees);				
				if container < table.getn(objectTable.inputFillTypes) then nextLine(true, distanceLine, false);end;
			end;			
		end;
	end;
	function setObjectDisplaySpecial(objectTable)
	end;
	if firstObjectDisplay <= moGuiMiniPdaSlots.values[slot].foundObjects then
		local splitObjectsFound = Utils.splitString(" ", moGuiMiniPdaSlots.values[slot].foundObjectsNamen);
		for a=firstObjectDisplay, moGuiMiniPdaSlots.values[slot].foundObjects do		
			if slotObjects[splitObjectsFound[a]] ~= nil then
				tempObjectDisplay = tempObjectDisplay+1;								
				if tonumber(a) > tonumber(endObjectDisplay) then break;end;				
				setObjectDisplay(slotObjects[splitObjectsFound[a]]);
				nextLine(true, 0.007, true, 0.0035, width+widthNext, 0.001);
			end;
		end;		
	end;
	---------------------------------------------------------------	
	moSetGetGui:setOverlay(self, moSetGetGui["designGround".. slot], posX-0.001, currentPosY+(heightSettings/2), width+widthNext, height+(heightSettings/2)); --+heightSettings	
	moGuiMiniPdaSlots.values[slot].openLastWidth = width+widthNext;
	moGuiMiniPdaSlots.values[slot].openLastHeight = height+(heightSettings/2); --+heightSettings	
	setTextColor(1, 1, 1, 1);
	setTextAlignment(0);
	setTextBold(false);	
end;

function moDraw.slots:setClickAreaSlotEdit(self, posX, posY, horizontal, vertical, objectTable, slot, slotName)	
	if objectTable == nil or slotName == nil or slot == nil then return;end;
	local a = Utils.getNoNil(table.getn(moGuiMiniPdaSlots.values[slot].clickArea.slotEdit), 0);	
	moGuiMiniPdaSlots.values[slot].clickArea.slotEdit[a+1] = {posX, posX+(horizontal), posY, posY+(vertical), objectTable, slotName };
end;

function moDraw.slots:setClickAreaHotSpot(self, posX, posY, horizontal, vertical, objX, objZ, name, slot)	
	if objX == nil or objZ == nil then return;end;
	local a = Utils.getNoNil(table.getn(moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot), 0);	
	moGuiMiniPdaSlots.values[slot].clickArea.slotHotSpot[a+1] = {posX, posX+(horizontal), posY, posY+(vertical), objX, objZ, name };
end;

function moDraw.slots:setClickAreaSeeSmall(self, posX, posY, horizontal, vertical, fillTypesString, name, slot)	
	local a = Utils.getNoNil(table.getn(moGuiMiniPdaSlots.values[slot].clickArea.slotSeeSmall), 0);	
	moGuiMiniPdaSlots.values[slot].clickArea.slotSeeSmall[a+1] = {posX, posX+(horizontal), posY, posY+(vertical), fillTypesString, name };
end;